{$V-}
{
        Program Name : Collect
        Package Name : Subroutine Library - Layer 1
        Purpose      : TCollection for Delphi
        Institution  : Conroy & Conroy Co.
        Date Written : 03-Jul-1996
	Last Modified: 17-May-2002
        Written By   : Alan Conroy
        Version      : 2.0A

        Copyright 1996-2002 by Alan Conroy.  Released to the public domain.
        
        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *  1-Nov-2002    EAC         Fix AtInsert.  Correct BP      *
	*			     compilation error.		    *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  This unit provides the TCollection definition to reduce the
        differences between the various versions of Borland Pascal/Delphi.  This
        is not in Compatib beecause of unit dependancy issues.  It also provides
        some other TCollection variants.
}

unit Collect ;

interface

{$I EDEFINES.INC}

{$IFDEF DELPHI}

uses { C&C Layer 1... }
     CommonUt, { Edit }

     { Borland... }
     Classes ; { TList }

type TCollection = object
                       private
                           List : TList ;

                       public
                           constructor Init( ALimit, ADelta : integer ) ;
                           destructor Done ;
                           function At( Index : integer ) : pointer ;
			   procedure AtPut( Index : integer ;
                               Value : pointer ) ;
                           function Count : integer ;
                           procedure Delete( Item : pointer ) ;
                           procedure AtDelete( Item : integer ) ;
                           function IndexOf( Item : pointer ) : integer ;
                           procedure Insert( Item : pointer ) ;
                           procedure DeleteAll ;
                           procedure AtInsert( Index : integer ;
                               Item : pointer ) ;
                           procedure SetLimit( ALimit : integer ) ;
                           function Limit : integer ;
  {$IFDEF Test}
			   procedure Test ;
  {$ENDIF}
                   end ;

type TString_Collection = object
                              private
                                  List : TStringList ;

                              public
                                  constructor Init( ALimit, ADelta : integer ) ;
                                  destructor Done ;
                                  function At( Index : integer ) : string ;
                                  procedure AtPut( Index : integer ;
                                      Value : string ) ;
                                  function Count : integer ;
                                  procedure Delete( Item : string ) ;
                                  procedure AtDelete( Item : integer ) ;
                                  function IndexOf( Item : string ) : integer ;
                                  function Index_Of_Uppercase( Item : string ) : integer ;
                                  procedure Insert( Item : String ) ;
                                  procedure DeleteAll ;
                                  procedure AtInsert( Index : integer ;
                                      Item : string ) ;
                                  procedure SetLimit( ALimit : integer ) ;
                                  function Limit : integer ;
  {$IFDEF Test}
				  procedure Test ;
  {$ENDIF}
                          end ;

type TInteger_Collection = object
                              private
                                  List : TList ;

                              public
                                  constructor Init( ALimit, ADelta : integer ) ;
                                  destructor Done ;
                                  function At( Index : integer ) : longint ;
                                  procedure AtPut( Index : integer ;
                                      Value : longint ) ;
                                  function Count : integer ;
                                  procedure Delete( Item : longint ) ;
                                  procedure AtDelete( Item : integer ) ;
                                  function IndexOf( Item : longint ) : integer ;
                                  procedure Insert( Item : longint ) ;
                                  procedure DeleteAll ;
                                  procedure AtInsert( Index : integer ;
				      Item : longint ) ;
                                  procedure SetLimit( ALimit : integer ) ;
                                  function Limit : integer ;
  {$IFDEF Test}
				  procedure Test ;
  {$ENDIF}
                          end ;
{$ELSE}
uses { C&C Layer 1... }
     CommonUt, { Edit }

     { Borland... }
     Objects ; { TCollection }

type TString_Collection = object
                              private
                                  List : TCollection ;

                              public
                                  constructor Init( ALimit, ADelta : integer ) ;
                                  destructor Done ; virtual ;
                                  function At( Index : integer ) : string ;
                                  procedure AtPut( Index : integer ;
                                      Value : string ) ;
                                  function Count : integer ;
                                  procedure Delete( Item : string ) ;
                                  procedure AtDelete( Item : integer ) ;
                                  function IndexOf( Item : string ) : integer ;
                                  procedure Insert( Item : String ) ;
                                  procedure DeleteAll ;
                                  procedure AtInsert( Index : integer ;
                                      Item : string ) ;
                                  procedure SetLimit( ALimit : integer ) ;
                                  function Limit : integer ;
  {$IFDEF Test}
				  procedure Test ;
  {$ENDIF}
                          end ;

type TInteger_Collection = object
                              private
                                  List : TCollection ;

                              public
                                  constructor Init( ALimit, ADelta : integer ) ;
                                  destructor Done ;
                                  function At( Index : integer ) : longint ;
                                  procedure AtPut( Index : integer ;
                                      Value : longint ) ;
                                  function Count : integer ;
                                  procedure Delete( Item : longint ) ;
                                  procedure AtDelete( Item : integer ) ;
                                  function IndexOf( Item : longint ) : integer ;
                                  procedure Insert( Item : longint ) ;
                                  procedure DeleteAll ;
                                  procedure AtInsert( Index : integer ;
				      Item : longint ) ;
                                  procedure SetLimit( ALimit : integer ) ;
                                  function Limit : integer ;
  {$IFDEF Test}
				  procedure Test ;
  {$ENDIF}
                          end ;
{$ENDIF}
     PCollection = ^TCollection ;
     PString_Collection = ^TString_Collection ;
     PInteger_Collection = ^TInteger_Collection ;

{$IFDEF Test}
procedure Test_Unit ;
{$ENDIF}

implementation

{$IFDEF DELPHI}
{ TCollection methods... }

{ API... }

constructor TCollection.Init( ALimit, ADelta : integer ) ;

begin
    List := TList.Create ;
    List.Capacity := ALimit ;
end ;


destructor TCollection.Done ;

begin
    List.Free ;
    List := nil ;
end ;


function TCollection.At( Index : integer ) : pointer ;

begin
    if( ( Index < 0 ) or ( Index > List.Count - 1 ) ) then
    begin
        At := nil ;
    end else
    begin
        At := List[ Index ] ;
    end ;
end ;


procedure TCollection.AtPut( Index : integer ; Value : pointer ) ;

begin
    List[ Index ] := Value ;
end ;


function TCollection.Count : integer ;

begin
    Count := List.Count ;
end ;


procedure TCollection.Delete( Item : Pointer ) ;

begin
    List.Remove( Item ) ;
end ;


procedure TCollection.AtDelete( Item : integer ) ;

begin
    List.Delete( Item ) ;
end ;


function TCollection.IndexOf( Item : Pointer ) : integer ;

begin
    IndexOf := List.IndexOf( Item ) ;
end ;


procedure TCollection.Insert( Item : Pointer ) ;

begin
    List.Add( Item ) ;
end ;


procedure TCollection.DeleteAll ;

begin
    while( Count > 0 ) do
    begin
        AtDelete( Count - 1 ) ;
    end ;
end ;


procedure TCollection.AtInsert( Index : integer ; Item : pointer ) ;

begin
    List.Insert( Index, Item ) ;
end ;


procedure TCollection.SetLimit( ALimit : integer ) ;

begin
    List.Capacity := ALimit ;
end ;


function TCollection.Limit : integer ;

begin
    Limit := List.Capacity ;
end ;


  {$IFDEF Test}
procedure TCollection.Test ;

var Loop : integer ;

begin
    if( Count <> 0 ) then
    begin
        writeln( 'Count <> 0' ) ;
        halt ;
    end ;
    if( IndexOf( pointer( 1 ) ) <> -1 ) then
    begin
        writeln( 'IndexOf is invalid' ) ;
        halt ;
    end ;
    for Loop := 0 to 5 do
    begin
        Insert( pointer( Loop * 2 ) ) ;
    end ;
    if( Count <> 6 ) then
    begin
        writeln( 'Count <> 6' ) ;
        halt ;
    end ;
    for Loop := 0 to 5 do
    begin
        if( At( Loop ) <> pointer( Loop * 2 ) ) then
        begin
            writeln( 'At returned wrong value' ) ;
            halt ;
        end ;
    end ;
    for Loop := 0 to 5 do
    begin
        AtPut( Loop, pointer( Loop * 2 + 1 ) ) ;
    end ;
    for Loop := 0 to 5 do
    begin
        if( At( Loop ) <> pointer( Loop * 2 + 1 ) ) then
        begin
            writeln( 'AtPut incorrect' ) ;
            halt ;
        end ;
    end ;
    if( Indexof( pointer( 3 ) ) <> 1 ) then
    begin
        writeln( 'Indexof incorrect' ) ;
        halt ;
    end ;
    Delete( pointer( 3 ) ) ;
    if( Indexof( pointer( 3 ) ) <> -1 ) then
    begin
        writeln( 'Delete malfunctioned' ) ;
        halt ;
    end ;
    for Loop := Count - 1 downto 0 do
    begin
        AtDelete( Loop ) ;
    end ;
    if( Count <> 0 ) then
    begin
        writeln( 'Count <> 0' ) ;
        halt ;
    end ;
    if( At( -1 ) <> nil ) then
    begin
        writeln( 'At( -1 ) did not return 0' ) ;
        halt ;
    end ;
end ;
  {$ENDIF}


{ TString_Collection methods... }

constructor TString_Collection.Init( ALimit, ADelta : integer ) ;

begin
    List := TStringList.Create ;
end ;


destructor TString_Collection.Done ;

begin
    List.Free ;
    List := nil ;
end ;


function TString_Collection.At( Index : integer ) : string ;

begin
    if( ( Index < 0 ) or ( Index > List.Count - 1 ) ) then
    begin
        At := '' ;
    end else
    begin
        At := List[ Index ] ;
    end ;
end ;


procedure TString_Collection.AtPut( Index : integer ; Value : string ) ;

begin
    List[ Index ] := Value ;
end ;


function TString_Collection.Count : integer ;

begin
    Count := List.Count ;
end ;


procedure TString_Collection.Delete( Item : string ) ;

begin
    AtDelete( Indexof( Item ) ) ;
end ;


procedure TString_Collection.AtDelete( Item : integer ) ;

begin
    List.Delete( Item ) ;
end ;


function TString_Collection.IndexOf( Item : string ) : integer ;

begin
    IndexOf := List.IndexOf( Item ) ;
end ;


function TString_Collection.Index_Of_Uppercase( Item : string ) : integer ;

var Loop : integer ;

begin
    Item := Edit( Item, 32 ) ;
    for Loop := 0 to Count - 1 do
    begin
        if( Item = Edit( At( Loop ), 32 ) ) then
        begin
            Index_Of_Uppercase := Loop ;
            exit ;
        end ;
    end ;
    Index_Of_Uppercase := -1 ;
end ;


procedure TString_Collection.Insert( Item : String ) ;

begin
    List.Add( Item ) ;
end ;


procedure TString_Collection.DeleteAll ;

begin
    while( Count > 0 ) do
    begin
        AtDelete( Count - 1 ) ;
    end ;
end ;


procedure TString_Collection.AtInsert( Index : integer ; Item : string ) ;

begin
    List.Insert( Index, Item ) ;
end ;


procedure TString_Collection.SetLimit( ALimit : integer ) ;

begin
    List.Capacity := ALimit ;
end ;


function TString_Collection.Limit : integer ;

begin
    Limit := List.Capacity ;
end ;



{ TInteger_Collection methods... }

constructor TInteger_Collection.Init( ALimit, ADelta : integer ) ;

begin
    List := TList.Create ;
end ;


destructor TInteger_Collection.Done ;

begin
    List.Free ;
    List := nil ;
end ;


function TInteger_Collection.At( Index : integer ) : longint ;

begin
    if( ( Index < 0 ) or ( Index > List.Count - 1 ) ) then
    begin
        At := 0 ;
    end else
    begin
        At := longint( List[ Index ] ) ;
    end ;
end ;


procedure TInteger_Collection.AtPut( Index : integer ; Value : longint ) ;

begin
    List[ Index ] := pointer( Value ) ;
end ;


function TInteger_Collection.Count : integer ;

begin
    Count := List.Count ;
end ;


procedure TInteger_Collection.Delete( Item : longint ) ;

begin
    AtDelete( Indexof( Item ) ) ;
end ;


procedure TInteger_Collection.AtDelete( Item : integer ) ;

begin
    List.Delete( Item ) ;
end ;


function TInteger_Collection.IndexOf( Item : longint ) : integer ;

begin
    IndexOf := List.IndexOf( pointer( Item ) ) ;
end ;


procedure TInteger_Collection.Insert( Item : longint ) ;

begin
    List.Add( pointer( Item ) ) ;
end ;


procedure TInteger_Collection.DeleteAll ;

begin
    while( Count > 0 ) do
    begin
        AtDelete( Count - 1 ) ;
    end ;
end ;


procedure TInteger_Collection.AtInsert( Index : integer ; Item : longint ) ;

begin
    List.Insert( Index, pointer( Item ) ) ;
end ;


procedure TInteger_Collection.SetLimit( ALimit : integer ) ;

begin
    List.Capacity := ALimit ;
end ;


function TInteger_Collection.Limit : integer ;

begin
    Limit := List.Capacity ;
end ;
{$ELSE}

uses { C&C Layer 1... }
     CommonUt, { Edit }
     TypeDefs ; { PSmall_String }

{ TString_Collection methods... }

constructor TString_Collection.Init( ALimit, ADelta : integer ) ;

begin
    List.Init( ALimit, ADelta ) ;
end ;


destructor TString_Collection.Done ;

var Loop : integer ;

begin
    for Loop := Count - 1 downto 0 do
    begin
        AtDelete( Loop ) ;
    end ;
    List.Done ;
end ;


function TString_Collection.At( Index : integer ) : string ;

var P : PSmall_String ;

begin
    P := PSmall_String( List.At( Index ) ) ;
    if( P = nil ) then
    begin
        At := '' ;
    end else
    begin
        At := P^ ;
    end ;
end ;


procedure TString_Collection.AtPut( Index : integer ; Value : string ) ;

var P : PSmall_String ;

begin
    P := PSmall_String( List.At( Index ) ) ;
    if( P <> nil ) then { Get rid of old string }
    begin
        freemem( P, length( P^ ) + 1 ) ;
    end ;
    getmem( P, length( Value ) + 1 ) ;
    P^ := Value ;
    List.AtPut( Index, P ) ;
end ;


function TString_Collection.Count : integer ;

begin
    Count := List.Count ;
end ;


procedure TString_Collection.Delete( Item : string ) ;

var Index : integer ;

begin
    Index := IndexOf( Item ) ;
    if( Index >= 0 ) then
    begin
        AtDelete( Index ) ;
    end ;
end ;


procedure TString_Collection.AtDelete( Item : integer ) ;

var P : PSmall_String ;

begin
    if( List.At( Item ) <> nil ) then
    begin
        P := PSmall_String( List.At( Item ) ) ;
        if( P <> nil ) then
        begin
            freemem( P, length( P^ ) + 1 ) ;
        end ;
    end ;
    List.AtDelete( Item ) ;
end ;


function TString_Collection.IndexOf( Item : string ) : integer ;

var Loop : integer ;

begin
    for Loop := 0 to Count - 1 do
    begin
        if( At( Loop ) = Item ) then
        begin
            Indexof := Loop ;
            exit ;
        end ;
    end ;
    Indexof := -1 ; { Did not find }
end ;


function TString_Collection.Index_Of_Uppercase( Item : string ) : integer ;

var Loop : integer ;

begin
    Item := Edit( Item, 32 ) ;
    for Loop := 0 to Count - 1 do
    begin
        if( Item = Edit( At( Loop ), 32 ) ) then
        begin
            Index_Of_Uppercase := Loop ;
            exit ;
        end ;
    end ;
    Index_Of_Uppercase := -1 ;
end ;


procedure TString_Collection.Insert( Item : String ) ;

var P : PSmall_String ;

begin
    getmem( P, length( Item ) + 1 ) ;
    P^ := Item ;
    List.Insert( P ) ;
end ;


procedure TString_Collection.DeleteAll ;

begin
    while( Count > 0 ) do
    begin
        AtDelete( Count - 1 ) ;
    end ;
end ;


procedure TString_Collection.AtInsert( Index : integer ; Item : string ) ;

var P : PSmall_String ;

begin
    getmem( P, length( Item ) + 1 ) ;
    P^ := Item ;
    List.AtInsert( Index, P ) ;
end ;


procedure TString_Collection.SetLimit( ALimit : integer ) ;

var Loop : integer ;

begin
    if( ALimit < Count ) then { Deleting some stuff }
    begin
        for Loop := Count - 1 downto ALimit do
        begin
            AtDelete( Loop ) ; { Make sure strings get freed }
        end ;
    end ;
    List.SetLimit( ALimit ) ;
end ;


function TString_Collection.Limit : integer ;

begin
    Limit := List.Limit ;
end ;



{ TInteger_Collection methods... }

constructor TInteger_Collection.Init( ALimit, ADelta : integer ) ;

begin
    List.Init( ALimit, ADelta ) ;
end ;


destructor TInteger_Collection.Done ;

var Loop : integer ;

begin
    for Loop := Count - 1 downto 0 do
    begin
        AtDelete( Loop ) ;
    end ;
    List.Done ;
end ;


function TInteger_Collection.At( Index : integer ) : longint ;

begin
    At := longint( List.At( Index ) ) ;
end ;


procedure TInteger_Collection.AtPut( Index : integer ; Value : longint ) ;

begin
    List.AtPut( Index, pointer( Value ) ) ;
end ;


function TInteger_Collection.Count : integer ;

begin
    Count := List.Count ;
end ;


procedure TInteger_Collection.Delete( Item : longint ) ;

begin
    List.Delete( pointer( Item ) ) ;
end ;


procedure TInteger_Collection.AtDelete( Item : integer ) ;

begin
    List.AtDelete( Item ) ;
end ;


function TInteger_Collection.IndexOf( Item : longint ) : integer ;

var Loop : integer ;

begin
    for Loop := 0 to Count - 1 do
    begin
        if( At( Loop ) = Item ) then
        begin
            Indexof := Loop ;
            exit ;
        end ;
    end ;
    Indexof := -1 ; { Did not find }
end ;


procedure TInteger_Collection.Insert( Item : longint ) ;

begin
    List.Insert( pointer( Item ) ) ;
end ;


procedure TInteger_Collection.DeleteAll ;

begin
    while( Count > 0 ) do
    begin
        AtDelete( Count - 1 ) ;
    end ;
end ;


procedure TInteger_Collection.AtInsert( Index : integer ; Item : longint ) ;

begin
    List.AtInsert( Index, pointer( Item ) ) ;
end ;


procedure TInteger_Collection.SetLimit( ALimit : integer ) ;

begin
    List.SetLimit( ALimit ) ;
end ;


function TInteger_Collection.Limit : integer ;

begin
    Limit := List.Limit ;
end ;
{$ENDIF}


{$IFDEF Test}
procedure TString_Collection.Test ;

var Loop : integer ;

    function itos( X : integer ) : string ;

    var S : string ;

    begin
        str( X, S ) ;
        itos := S ;
    end ;

begin
    if( Count <> 0 ) then
    begin
        writeln( 'Count <> 0' ) ;
        halt ;
    end ;
    if( IndexOf( '1' ) <> -1 ) then
    begin
        writeln( 'IndexOf is invalid' ) ;
        halt ;
    end ;
    for Loop := 0 to 5 do
    begin
        Insert( itos( Loop * 2 ) ) ;
    end ;
    if( Count <> 6 ) then
    begin
        writeln( 'Count <> 6' ) ;
        halt ;
    end ;
    for Loop := 0 to 5 do
    begin
        if( At( Loop ) <> itos( Loop * 2 ) ) then
        begin
            writeln( 'At returned wrong value' ) ;
            halt ;
        end ;
    end ;
    for Loop := 0 to 5 do
    begin
        AtPut( Loop, itos( Loop * 2 + 1 ) ) ;
    end ;
    for Loop := 0 to 5 do
    begin
        if( At( Loop ) <> itos( Loop * 2 + 1 ) ) then
        begin
            writeln( 'AtPut incorrect' ) ;
            halt ;
        end ;
    end ;
    if( Indexof( '3' ) <> 1 ) then
    begin
        writeln( 'Indexof incorrect' ) ;
        halt ;
    end ;
    Delete( '3' ) ;
    if( Indexof( '3' ) <> -1 ) then
    begin
        writeln( 'Delete malfunctioned' ) ;
        halt ;
    end ;
    for Loop := Count - 1 downto 0 do
    begin
        AtDelete( Loop ) ;
    end ;
    if( Count <> 0 ) then
    begin
        writeln( 'Count <> 0' ) ;
        halt ;
    end ;
    if( At( -1 ) <> '' ) then
    begin
        writeln( 'At( -1 ) did not return null string' ) ;
        halt ;
    end ;
end ;


procedure TInteger_Collection.Test ;

var Loop : integer ;

begin
    if( Count <> 0 ) then
    begin
        writeln( 'Count <> 0' ) ;
        halt ;
    end ;
    if( IndexOf( 1 ) <> -1 ) then
    begin
        writeln( 'IndexOf is invalid' ) ;
        halt ;
    end ;
    for Loop := 0 to 5 do
    begin
        Insert( Loop * 2 ) ;
    end ;
    if( Count <> 6 ) then
    begin
        writeln( 'Count <> 6' ) ;
        halt ;
    end ;
    for Loop := 0 to 5 do
    begin
        if( At( Loop ) <> Loop * 2 ) then
        begin
            writeln( 'At returned wrong value' ) ;
            halt ;
        end ;
    end ;
    for Loop := 0 to 5 do
    begin
        AtPut( Loop, Loop * 2 + 1 ) ;
    end ;
    for Loop := 0 to 5 do
    begin
        if( At( Loop ) <> Loop * 2 + 1 ) then
        begin
            writeln( 'AtPut incorrect' ) ;
            halt ;
        end ;
    end ;
    if( Indexof( 3 ) <> 1 ) then
    begin
        writeln( 'Indexof incorrect' ) ;
        halt ;
    end ;
    Delete( 3 ) ;
    if( Indexof( 3 ) <> -1 ) then
    begin
        writeln( 'Delete malfunctioned' ) ;
        halt ;
    end ;
    for Loop := Count - 1 downto 0 do
    begin
        AtDelete( Loop ) ;
    end ;
    if( Count <> 0 ) then
    begin
        writeln( 'Count <> 0' ) ;
        halt ;
    end ;
    if( At( -1 ) <> 0 ) then
    begin
        writeln( 'At( -1 ) did not return 0' ) ;
        halt ;
    end ;
end ;


procedure Test_Unit ;

var TC : TCollection ;
    TSC : TString_Collection ;
    TIC : TInteger_Collection ;

begin
    TC.Init( 0, 4 ) ;
    TSC.Init( 0, 4 ) ;
    TIC.Init( 0, 4 ) ;

{$IFDEF DELPHI}
    TC.Test ;
{$ENDIF}
    TSC.Test ;
    TIC.Test ;

    TC.Done ;
    TSC.Done ;
    TIC.Done ;
end ;
{$ENDIF}


end.
