{
        Program Name : Presentr
        Package Name : LB
        Purpose      : Output presenter (displayer)
        Institution  : Conroy & Conroy Co.
        Date Written : 24-Dec-2005
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2005 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  The classes in this unit are used to present information to the
        user.  This may be text to be output within a window, or bitmap on
	a printer, etc.
}

unit Presentr ;

interface

{$I EDEFINES.INC}

uses { Borland... }
     Classes. { TList }
     Graphics, { TColor }

     { Layer 0... }
     Common ; { TBase_Delphi_Object }

type TBorder = class( TBase_Delphi_Object )
		   private { Instance data... }
		       _Color : TColor ;
		       _Thickness : TRect ; { Thickness of each border, in pixels }
		       _Margins : TRect ; { Pixel margins outside of border }

		   public { API... }
		       procedure Render( DC : THandle ; Rect : TRect ) ;
               end ;

type TCharacter_Format = (
			     CHF_ASCII,
			     CHF_Unicode
                         ) ;

type TCharacter = class( TBase_Delphi_Object )
		      private { Instance data }
			  _Value : longint ; { The character value }
			  _Format : TCharacter_Format ;
			  _Background_Color : TColor ;
			  _Foreground_Color : TColor ;
			  _Orientation : integer ;
			  _Weight : integer ;
			  _Italics : integer ;
			  _Font : TFont ; { nil if UNICODE }
			  _Size : integer ; { Point size (if 0, use _Font ) }
			  _Margin : TRect ; { Pixel margins }
			  _Border : TBorder ; { nil if none }
			  _Effects : TList ; { List of effects applied to character }

		      public { API... }
			  function Character : char ; { Value as char }
			  procedure Render( DC : THandle ; X, Y : integer ) ;
			  function Whitespace : boolean ; { True if whitespace }

		      published
			  property Font : TFont
			      read _Value
			      write _Value ;
			  property Value : longint
			      read _Value
			      write _Value ;
                  end ; { TCharacter }

implementation

end.
