{
        Program Name : UEHDefs
        Package Name : Subroutine Library - Layer 1
        Purpose      : UEH definitions
        Institution  : Conroy & Conroy Co.
        Date Written : 10-Jan-1999
        Last Modified: 19-May-2002
        Written By   : Alan Conroy
        Version      : 1.2

        Copyright (C) 2002 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

	  This unit provides definitions for UEH.
}

unit UEHDefs ;

interface

{$I EDEFINES.INC}

uses { C&C Subroutine Library - layer 0 }
     _UEHDefs ; { TError_Interface }

{$IFDEF DELPHI}
type TStandard_Error_Interface = class( TError_Interface )
                                     public
                                         function Get_Facility : longint ;
                                             override ;
                                         function Get_Name : PChar ; override ;
                                         function Translate_Error( Code : longint ) : PChar ;
                                             override ;
                                         procedure Done ; override ;
                                         function Facility_Version : longint ;
                                             override ;
                                         function Version : longint ; override ;

                                         { V1.2 support... }
                                         function Severity( Code : longint ) : longint ;
                                             override ;
                                         function Translate_Error_Ex( Code : longint ;
                                             var Size, Typ : longint ) : PChar ;
                                             override ;
                                 end ;
{$ENDIF}

type TSStandard_Error_Interface = object( TSError_Interface )
                                      public
                                          function Get_Facility : longint ;
                                              virtual ;
                                          function Get_Name : string ; virtual ;
                                          function Translate_Error( Code : longint ) : string ;
                                              virtual ;
                                          function Facility_Version : longint ;
                                              virtual ;
                                          function Version : longint ;
                                              virtual ;
                                          function Severity( Code : longint ) : longint ;
                                              virtual ;
                                          function Translate_Error_Ex( Code : longint ;
                                              var Size, Typ : longint ) : string ;
                                              virtual ;
                                  end ;
     PSStandard_Error_Interface = ^TSStandard_Error_Interface ;

implementation

{$IFDEF DELPHI}
uses { Borland... }
     Sysutils ; { strpas }
{$ELSE}
uses Strings ; { strlen }
{$ENDIF}

{ TStandard_Error_Interface methods... }

function TSStandard_Error_Interface.Get_Facility : longint ;

begin
    Get_Facility := -1 ;
end ;


function TSStandard_Error_Interface.Get_Name : string ;

begin
    Get_Name := '' ;
end ;


function TSStandard_Error_Interface.Translate_Error( Code : longint ) : string ;

begin
    Translate_Error := '' ;
end ;


function TSStandard_Error_Interface.Facility_Version : longint ;

begin
    Facility_Version := 0 ;
end ;


function TSStandard_Error_Interface.Version : longint ;

begin
    Version := 12 ; { Complies with UEH V1.2 specification }
end ;


function TSStandard_Error_Interface.Severity( Code : longint ) : longint ;

begin
    Severity := UEH_Error ; { Error }
end ;


function TSStandard_Error_Interface.Translate_Error_Ex( Code : longint ;
    var Size, Typ : longint ) : string ;

var P : string ;

begin
    P := Translate_Error( Code ) ;
    Size := length( P ) ;
    Typ := 0 ; { 7-bit ASCII }
    Translate_Error_Ex := P ;
end ;


{$IFDEF DELPHI}
{ TStandard_Error_Interface methods... }

procedure TStandard_Error_Interface.Done ;

begin
    { This method left intentionally blank }
end ;


function TStandard_Error_Interface.Get_Facility : longint ;

begin
    Get_Facility := -1 ;
end ;


function TStandard_Error_Interface.Get_Name : PChar ;

begin
    Get_Name := nil ;
end ;


function TStandard_Error_Interface.Translate_Error( Code : longint ) : PChar ;

begin
    Translate_Error := nil ;
end ;


function TStandard_Error_Interface.Facility_Version : longint ;

begin
    Facility_Version := 0 ;
end ;


function TStandard_Error_Interface.Version : longint ;

begin
    Version := 12 ; { Complies with UEH V1.2 specification }
end ;


function TStandard_Error_Interface.Severity( Code : longint ) : longint ;

begin
    Severity := UEH_Error ; { Error }
end ;


function TStandard_Error_Interface.Translate_Error_Ex( Code : longint ;
    var Size, Typ : longint ) : PChar ;

var P : PChar ;

begin
    P := Translate_Error( Code ) ;
    if( P = nil ) then
    begin
        Size := 0 ;
    end else
    begin
        Size := strlen( P ) ;
    end ;
    Typ := 0 ; { 7-bit ASCII }
    Translate_Error_Ex := P ;
end ;
{$ENDIF}



end.

