{
        Program Name : _DebugMa
        Package Name : LB
        Purpose      : Debug Manager pure virtual classes
        Institution  : Conroy & Conroy Co.
        Date Written : 15-August-2003
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2003 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *    DATE        BY          REASON                         *
        *                                                           *
        *************************************************************

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          The classes in this unit define the Debug Manager interface.
}

unit _DebugMa ;

interface

uses Common, { TBase_Object }
     ComInter, { TCommon_COM_Interface }
     _DebugIn ; { PDebug_Interface }

{$I EDEFINES.INC}

{$IFDEF DELPHI}
type TUnit_Debugger = class( TBase_Delphi_Object )
                          public { API... }
                              { Returns the name of the unit }
                              function Get_Name : string ;
                                  virtual ; abstract ;

                              { Creates and returns an instance of a unit debug
                                interface }
                              function Get_Instance : PSDebug_Interface ;
                                  virtual ; abstract ;
                      end ;

type TDebug_Manager = class( TBase_Delphi_Object )
                          public { Unit debugger support... }
                              function Get_Unit_Debugger( Index : longint ) : TUnit_Debugger ;
                                  virtual ; abstract ;

                              { Register a unit debugger }
                              procedure Register_Unit_Debugger( D : TUnit_Debugger ) ;
                                  virtual ; abstract ;

                              { Remove a registered unit debugger }
                              procedure Remove_Unit_Debugger( D : TUnit_Debugger ) ;
                                  virtual ; abstract ;

                              { Returns count of registered unit debuggers }
                              function Unit_Debugger_Count : longint ;
                                  virtual ; abstract ;
                      end ;

type TCOM_Unit_Debugger = class( TCommon_COM_Interface )
                              public { API... }
                                  { Returns the name of the unit }
                                  function Get_Name : PChar ;
                                      virtual ; stdcall ; abstract ;

                                  { Creates and returns an instance of a unit debug
                                    interface }
                                  function Get_Instance : TDebug_Interface ;
                                      virtual ; stdcall ; abstract ;
                          end ;

type TCOM_Debug_Manager = class( TCommon_COM_Interface )
                              public { Unit debugger support... }
                                  function Get_Unit_Debugger( Index : longint ) : TCOM_Unit_Debugger ;
                                      virtual ; stdcall ; abstract ;

                                  { Register a unit debugger }
                                  procedure Register_Unit_Debugger( D : TCOM_Unit_Debugger ) ;
                                      virtual ; stdcall ; abstract ;

                                  { Remove a registered unit debugger }
                                  procedure Remove_Unit_Debugger( D : TCOM_Unit_Debugger ) ;
                                      virtual ; stdcall ; abstract ;

                                  { Returns count of registered unit debuggers }
                                  function Unit_Debugger_Count : longint ;
                                      virtual ; stdcall ; abstract ;
                          end ;
{$ENDIF}

type TSUnit_Debugger = object( TBase_Object )
                          public { API... }
                              { Returns the name of the unit }
                              function Get_Name : string ;
                                  virtual ;

                              { Creates and returns an instance of a unit debug
                                interface }
                              function Get_Instance : PSDebug_Interface ;
                                  virtual ;
                      end ;
     PSUnit_Debugger = ^TSUnit_Debugger ;

type TSDebug_Manager = object( TBase_Object )
                          public { Unit debugger support... }
                              function Get_Unit_Debugger( Index : longint ) : PSUnit_Debugger ;
                                  virtual ;

                              { Register a unit debugger }
                              procedure Register_Unit_Debugger( D : PSUnit_Debugger ) ;
                                  virtual ;

                              { Remove a registered unit debugger }
                              procedure Remove_Unit_Debugger( D : PSUnit_Debugger ) ;
                                  virtual ;

                              { Returns count of registered unit debuggers }
                              function Unit_Debugger_Count : longint ;
                                  virtual ;
                      end ;
     PSDebug_Manager = ^TSDebug_Manager ;

implementation

function TSUnit_Debugger.Get_Name : string ;

begin
    Get_Name := '' ;
end ;


function TSUnit_Debugger.Get_Instance : PSDebug_Interface ;

begin
    Get_Instance := nil ;
end ;


function TSDebug_Manager.Get_Unit_Debugger( Index : longint ) : PSUnit_Debugger ;

begin
    Get_Unit_Debugger := nil ;
end ;


procedure TSDebug_Manager.Register_Unit_Debugger( D : PSUnit_Debugger ) ;

begin
    { Intentionally left blank }
end ;


procedure TSDebug_Manager.Remove_Unit_Debugger( D : PSUnit_Debugger ) ;

begin
    { Intentionally left blank }
end ;


function TSDebug_Manager.Unit_Debugger_Count : longint ;

begin
    Unit_Debugger_Count := 0 ;
end ;


end.
