/*
              Program Name : Standard
              Package Name : LB
              Purpose      : Standard routines
              Institution  : Conroy & Conroy Compnay
              Date Written : 29-Oct-88
              Written By   : Alan Conroy
              Version      : 1.0

	      Copyright (C) 1988 by Alan Conroy.  Released to the public domain.

              TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *     DATE      BY             REASON                   *
        *                                                       *
        *********************************************************

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          Standard utility functions.
*/

#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "standard.h"

/*
This function returns the current version of MSDOS/PCDOS.
*/

char *OD_IS()
{

union REGS Reg ;
char Buffer[ 256 ], V1[ 5 ], V2[ 5 ] ;

    Reg.w.ax = 0x3000 ;
    intdos( &Reg, &Reg ) ; /* Call MSDOS for version */
    itoa( Reg.h.al, V1, 10 ) ;
    itoa( Reg.h.ah, V2, 10 ) ;
    strcpy( Buffer, "MSDOS V" ) ;
    strcat( Buffer, V1 ) ;
    strcat( Buffer, "." ) ;
    strcat( Buffer, V2 ) ;
    return &Buffer ;
} ;


/*
Return date in dd-mmm-yyyy format.
*/

char *Date()
{

    char Day_String[ 5 ], Year_String[ 5 ] ;
    static char Buffer[ 12 ] ;
    struct tm *Temp ;
    time_t *Timer ;

    time( &Timer ) ;
    Temp = localtime( &Timer ) ;
    itoa( 1900 + Temp -> tm_year, Year_String, 10 ) ;
    itoa( Temp -> tm_mday, Day_String, 10 ) ;
    /* Convert day and year to strings */

    if ( strlen( Day_String ) == 1 )
    {
	Day_String[ 2 ] = 0 ;
	Day_String[ 1 ] = Day_String[ 0 ] ;
	Day_String[ 0 ] = '0' ;
    } ;
    strcpy( Buffer, Day_String ) ;
    strcat( Buffer, "-" ) ;
    switch ( Temp -> tm_mon )
    {
	case 1 :
	    strcat( Buffer, "Jan" ) ;
	    break ;
	case 2 :
	    strcat( Buffer, "Feb" ) ;
	    break ;
	case 3 :
	    strcat( Buffer, "Mar" ) ;
	    break ;
	case 4 :
	    strcat( Buffer, "Apr" ) ;
	    break ;
	case 5 :
	    strcat( Buffer, "May" ) ;
	    break ;
	case 6 :
	    strcat( Buffer, "Jun" ) ;
	    break ;
	case 7 :
	    strcat( Buffer, "Jul" ) ;
	    break ;
	case 8 :
	    strcat( Buffer, "Aug" ) ;
	    break ;
	case 9 :
	    strcat( Buffer, "Sep" ) ;
	    break ;
	case 10 :
	    strcat( Buffer, "Oct" ) ;
	    break ;
	case 11 :
	    strcat( Buffer, "Nov" ) ;
	    break ;
	case 12 :
	    strcat( Buffer, "Dec" ) ;
	    break ;
    } ;
    strcat( Buffer, "-" ) ;
    strcat( Buffer, Year_String ) ;
    return &Buffer ; /* Now return value */
} ;



/* Time function. */

char *Time()
{
    char AM_PM[ 3 ] ;
    int Hour, Minute ;
    char Hour_String[ 3 ] ;
    char Minute_String[ 3 ] ;
    struct tm *Temp ;
    static char Buffer[ 9 ] ;
    time_t *Timer ;

    time( &Timer ) ;
    Temp = localtime( &Timer ) ;
    Hour = Temp -> tm_hour ;
    Minute = Temp -> tm_min ;
    strcpy( AM_PM, "AM" ) ;
    if ( Hour > 11 )
    {
	strcpy( AM_PM, "PM" ) ;
	if ( Hour > 12 )
	{
	    Hour = Hour - 12 ;
	} ; /* if (Hour > 12 ) */
    } ; /* if ( Hour > 11 ) */
    if ( Hour == 0 )
    {
	Hour = 12 ;
    } ; /* if( Hour == 0 ) */
    itoa( Hour, Hour_String, 10 ) ;
    itoa( Minute, Minute_String, 10 ) ; /* Convert hour and minute to strings */
    if ( strlen( Minute_String ) == 1 ) /* Needs leading zero */
    {
	Minute_String[ 2 ] = 0 ;
	Minute_String[ 1 ] = Minute_String[ 2 ] ;
	Minute_String[ 0 ] = '0' ;
    } ;
    strcpy( Buffer, Hour_String ) ;
    strcat( Buffer, ":" ) ;
    strcat( Buffer, Minute_String ) ;
    strcat( Buffer, " " ) ;
    strcat( Buffer, AM_PM ) ;
    return &Buffer ;
} ; /* Time */



/*
Extended time function.
*/

char *XTime()
{

    union REGS Registers ;
    char Hour_String[ 3 ], Minute_String[ 3 ], Second_String[ 3 ],
	 Hundreths_String[ 3 ], AM_PM[ 3 ] ;
    static char Buffer[ 15 ] ;

    Registers.h.ah = 0x2C ;
    intdos( &Registers, &Registers ) ;
    strcpy( AM_PM, "AM" ) ;
    if ( Registers.h.ch > 11 )
    {
        strcpy( AM_PM, "PM" ) ;
        if ( Registers.h.ch > 12 )
	{
	    Registers.h.ch = Registers.h.ch - 12 ;
	} ;
    } ;
    if ( Registers.h.ch == 0 )
    {
	Registers.h.ch = 12 ;
    } ;
    itoa( Registers.h.ch, Hour_String, 10 ) ;
    itoa( Registers.h.cl, Minute_String, 10 ) ;
    /* Convert hour and minute to strings */
    itoa( Registers.h.dh, Second_String, 10 ) ; /* Convert seconds to string */
    itoa( Registers.h.dl, Hundreths_String, 10 ) ;
    /* Convert hundreths to string */

    if ( strlen( Minute_String ) == 1 )
    {
	Minute_String[ 2 ] = 0 ;
	Minute_String[ 1 ] = Minute_String[ 0 ] ;
	Minute_String[ 0 ] = '0' ;
    } ;
    if ( strlen( Second_String ) == 1 )
    {
	Second_String[ 2 ] = 0 ;
	Second_String[ 1 ] = Second_String[ 0 ] ;
	Second_String[ 0 ] = '0' ;
    } ;
    if ( strlen( Hundreths_String ) == 1 )
    {
	Hundreths_String[ 2 ] = 0 ;
	Hundreths_String[ 1 ] = Hundreths_String[ 0 ] ;
	Hundreths_String[ 0 ] = '0' ;
    } ;
    strcpy( Buffer, Hour_String ) ;
    strcat( Buffer, ":" ) ;
    strcat( Buffer, Minute_String ) ;
    strcat( Buffer, ":" ) ;
    strcat( Buffer, Second_String ) ;
    strcat( Buffer, "." ) ;
    strcat( Buffer, Hundreths_String ) ;
    strcat( Buffer, " " ) ;
    strcat( Buffer, AM_PM ) ;
    return &Buffer ;
} ; /* XTime */


/*
Return DOS extended error code.
*/

int MSDOS_Error()
{

    struct DOSERROR Temp ;

    if ( _osmajor < 3 )
    {
	return 31 ; /* No extended error function until version 3 */
    } else
    {
	return Temp.de_exterror ;
    } ;
} ;


/*
Return DOS error text.
*/

char* ERT( int Err )
{

	 char A[ 64 ] ;

	 switch ( Err ) /* First handle "synonyms" */
	 {
		  case 150 :
				Err = 19 ;
				break ;
		  case 151 :
				Err = 20 ;
				break ;
		  case 152 :
				Err = 21 ;
				break ;
		  case 153 :
				Err = 22 ;
				break ;
		  case 154 :
				Err = 23 ;
				break ;
		  case 155 :
				Err = 24 ;
				break ;
		  case 156 :
				Err = 25 ;
				break ;
		  case 157 :
				Err = 26 ;
				break ;
		  case 158 :
				Err = 27 ;
				break ;
		  case 159 :
				Err = 28 ;
				break ;
		  case 160 :
				Err = 29 ;
				break ;
		  case 161 :
				Err = 30 ;
				break ;
	 }
	 switch ( Err )
	 {
		  case 1 : return "Invalid function number" ;
		  case 2 : return "File not found" ;
		  case 3 : return "Path not found" ;
		  case 4 : return "Too many open files" ;
		  case 5 : return "File access denied" ;
		  case 6 : return "Invalid file handle" ;
		  case 7 : return "Memory blocks destroyed" ;
		  case 8 : return "Insufficient memory" ;
		  case 9 : return "Invalid memory block address" ;
		 case 10 : return "Invalid environment" ;
		 case 11 : return "Invalid format" ;
		 case 12 : return "Invalid file access code" ;
		 case 13 : return "Invalid data" ;
		 case 14 : return "Unknown unit" ;
		 case 15 : return "Invalid drive number" ;
		 case 16 : return "Cannot remove current directory" ;
		 case 17 : return "Cannot rename across drives" ;
		 case 18 : return "No more files" ;
		 case 19 : return "Disk is write-protected" ;
		 case 20 : return "Unknown unit" ;
		 case 21 : return "Drive not ready" ;
		 case 22 : return "Unknown command" ;
		 case 23 : return "CRC error in data" ;
		 case 24 : return "Bad request structure length" ;
		 case 25 : return "Disk seek error" ;
		 case 26 : return "Unknown media type" ;
		 case 27 : return "Sector not found" ;
		 case 28 : return "Printer out of paper" ;
		 case 29 : return "Device write fault" ;
		 case 30 : return "Device read fault" ;
		 case 31 : return "General failure" ;
		 case 32 : return "Sharing violation" ;
		 case 33 : return "Lock violation" ;
		 case 34 : return "Invalid disk change" ;
		 case 35 : return "FCB unavailable" ;
		 case 36 : return "Sharing buffer exceeded" ;
		 case 50 : return "Unsupported network request" ;
		 case 51 : return "Remote machine not listening" ;
		 case 52 : return "Duplicate name on network" ;
		 case 53 : return "Network name not found" ;
		 case 54 : return "Network busy" ;
		 case 55 : return "Device no longer exists on network" ;
		 case 56 : return "netBIOS command limit exceeded" ;
		 case 57 : return "Error in network adapter hardware" ;
		 case 58 : return "Incorrect response from network" ;
		 case 59 : return "Unexpected network error" ;
		 case 60 : return "Remote adapter incompatible" ;
		 case 61 : return "Print queue full" ;
		 case 62 : return "Queue not full" ;
		 case 63 : return "Not enough room for print file" ;
		 case 64 : return "Network name deleted" ;
		 case 65 : return "Access denied" ;
		 case 66 : return "Incorrect network device type" ;
		 case 67 : return "Network name not found" ;
		 case 68 : return "Network name limit exceeded" ;
		 case 69 : return "netBIOS session limit exceeded" ;
		 case 70 : return "Temporary pause" ;
		 case 71 : return "Network request not accepted" ;
		 case 72 : return "Print or disk redirection paused" ;
		 case 80 : return "File already exists" ;
		 case 82 : return "Cannot make directory" ;
		 case 83 : return "Fail on Int 24H (critical error)" ;
		 case 84 : return "Out of structures" ;
		 case 85 : return "Already assigned" ;
		 case 86 : return "Invalid password" ;
		 case 87 : return "Invalid parameter" ;
		 case 88 : return "Net write fault" ;
		case 100 : return "Disk read error" ;
		case 101 : return "Disk write error" ;
		case 102 : return "File not assigned" ;
		case 103 : return "File not open" ;
		case 104 : return "File not open for input" ;
		case 105 : return "File not open for output" ;
		case 106 : return "Invalid numeric format" ;
		case 150 : return "Disk is write protected" ;
		case 151 : return "Unknown unit" ;
		case 152 : return "Drive not ready" ;
		case 153 : return "Unknown command" ;
		case 154 : return "CRC error in data" ;
		case 155 : return "Bad drive request structure length" ;
		case 156 : return "Disk seek error" ;
		case 157 : return "Unknown media type" ;
		case 158 : return "Sector not found" ;
		case 159 : return "Printer out of paper" ;
		case 160 : return "Device write fault" ;
		case 161 : return "Device read fault" ;
		case 162 : return "Hardware failure" ;
		case 200 : return "Division by zero" ;
		case 201 : return "Range check error" ;
		case 202 : return "Stack overflow error" ;
		case 203 : return "Heap overflow error" ;
		case 204 : return "Invalid pointer operation" ;
		case 205 : return "Floating point overflow" ;
		case 206 : return "Floating point underflow" ;
		case 207 : return "Invalid floating point operation" ;
		case 208 : return "Overlay manager not installed" ;
		case 209 : return "Overlay file read error" ;
		case 210 : return "Object not initialized" ;
		case 211 : return "Call to abstract method" ;
		case 212 : return "Stream registration error" ;
		case 213 : return "Collection index out of range" ;
		case 214 : return "Collection overflow error" ;
		case 215 : return "Arithmetic overflow" ;
		case 216 : return "General Protection fault" ;
	 } ;
	 strcpy( A, "Unused error number " ) ;
	 itoa( Err, &A[ 21 ], 10 ) ;
	 return *A ;
} ;


int Extension_Pos( char *X )
{

int Dummy ;

    Dummy = strlen( X ) ; /* Start at end of filename */
    while( Dummy >= 0 && X[ Dummy ] != '.' && X[ Dummy ] != '\\' )
    {
	Dummy = Dummy - 1 ; /* Work our way backwards until found or done */
    } ;
    if( Dummy < 0 ) /* Not found */
    {
	Dummy = 0 ;
    }
    else
    {
	if( X[ Dummy ] != '.' )
	{
	    Dummy = 0 ;
	}
	else
	{
	    Dummy = Dummy + 1 ;
	} ;
    } ;
    return Dummy ; /* Return result */
} ;

